/*================================================================================================================*/
// ********************************* THESE ARE THE INFORMATIONS OF THE MAP: ************************************* //
/*================================================================================================================*/

// THE NORTHWEST LAKE:
// CREATED BY DANY:
// JANUARY 2008:

/*================================================================================================================*/
// ********************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************ //
/*================================================================================================================*/

include "mercenaries.xs";
void main(void)
{
		
/*================================================================================================================*/		
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// **************************************** SET UP THE NATIVE TRIBES:  ****************************************** //
/*================================================================================================================*/

        int whichMap=rmRandInt(1,2);        
		
/*---------------------------------------------------------------------------------------------------------------*/		
		int subCiv0=-1;
	    int subCiv1=-1;
	    int subCiv2=-1;
	    int subCiv3=-1;
		int subCiv4=-1;
		int subCiv5=-1;
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // ALL INCA ALL THE TIME:
        if (rmAllocateSubCivs(6) == true)
{
		subCiv0=rmGetCivID("Nootka");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Nootka");

		subCiv1=rmGetCivID("Klamath");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Klamath");

		subCiv2=rmGetCivID("Nootka");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Nootka");

		subCiv3=rmGetCivID("Klamath");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Klamath");
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		if ( whichMap == 1 )
		
	{	
		subCiv4=rmGetCivID("Nootka");
        if (subCiv4 >= 0)
        rmSetSubCiv(4, "Nootka");

		subCiv5=rmGetCivID("Nootka");
        if (subCiv5 >= 0)
        rmSetSubCiv(5, "Nootka");
    }
	    else
	{	
		subCiv4=rmGetCivID("Klamath");
        if (subCiv4 >= 0)
        rmSetSubCiv(4, "Klamath");

		subCiv5=rmGetCivID("Klamath");
        if (subCiv5 >= 0)
        rmSetSubCiv(5, "Klamath");
	}	
		
}
	
/*================================================================================================================*/		
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************* PICKS THE MAP SIZE: ********************************************** //
/*================================================================================================================*/

        int teamZeroCount = rmGetNumberPlayersOnTeam(0);
        int teamOneCount = rmGetNumberPlayersOnTeam(1);
		
	    int playerTiles=22500;
	    
	    int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(600, 600);

/*================================================================================================================*/		
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// **************************************** DEFINE THE MAP PARAMETERS: ****************************************** //	
/*================================================================================================================*/

	    // SET WIND MAGNITUDE:
		rmSetWindMagnitude(2);

	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(0);

	    // PICKS DEFAULT TERRAIN AND WATER:
	    //	rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation)
	    //rmSetMapElevationParameters(cElevTurbulence, 0.04, 4, 0.4, 6.0);
		rmSetMapElevationParameters(cElevTurbulence, 0.04, 4, 0.4, 4.0);
	
	    // rmSetSeaType("NW Territory River");
	    rmSetSeaType("New England Coast");
	    
		// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("nwt_grass1");
	    
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("NWterritory\ground_grass1_nwt", 5);
	    
		// SET MAP TYPE:
		rmSetMapType("northwestTerritory");
	    rmSetMapType("grass");
	    rmSetMapType("water");
	    
		// SET LIGHTING:
		rmSetLightingSet("nwterritory");
	    
		// SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);
		
		// CHOOSE MERCS:
		chooseMercs();
	
/*================================================================================================================*/		
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/

	    int classPlayer=rmDefineClass("player");
	    rmDefineClass("starting settlement");
	    rmDefineClass("startingUnit");
	    rmDefineClass("classForest");
	    rmDefineClass("importantItem");
	    rmDefineClass("natives");
	    rmDefineClass("classSocket");
		rmDefineClass("classTrees");
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ******************************************* DEFINE CONSTRAINTS: ********************************************** //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/
  
    // MAP EDGE CONSTRAINTS:
    int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));
	int playerCloseEdgeConstraint=rmCreatePieConstraint("Close player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.485), rmDegreesToRadians(0), rmDegreesToRadians(360));
	
    // Cardinal Directions
    int Northward=rmCreatePieConstraint("northMapConstraint", 0.50, 0.50, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
    int Southward=rmCreatePieConstraint("southMapConstraint", 0.50, 0.50, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
    int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.50, 0.50, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
    int Westward=rmCreatePieConstraint("westMapConstraint", 0.50, 0.50, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

	// PLAYER CONSTRAINTS:
    int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 30.0);
	int playerCloseConstraint=rmCreateClassDistanceConstraint("close vs players", classPlayer, 10.0);
	int playerVeryCloseConstraint=rmCreateClassDistanceConstraint("very close vs players", classPlayer, 5.0);
	int playerFarConstraint=rmCreateClassDistanceConstraint("far vs players", classPlayer, 45.0);
 
    // SEAFOOD AVOIDANCE:
    int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 12.0);
    int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
      
    // FORESTS AVOIDANCE:
    int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 30.0);
    int forestCloseConstraint=rmCreateClassDistanceConstraint("close vs. forest", rmClassID("classForest"), 10.0);
    int forestVeryCloseConstraint=rmCreateClassDistanceConstraint("very close vs. forest", rmClassID("classForest"), 5.0);
   	int forestFarConstraint=rmCreateClassDistanceConstraint("far vs. forest", rmClassID("classForest"), 45.0);
   
    //int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 10.0);
	
	// TREES AVOIDANCE:
	int avoidTrees=rmCreateClassDistanceConstraint("stuff avoid Trees", rmClassID("classTrees"), 15.0);
	int avoidCloseTrees=rmCreateClassDistanceConstraint("close avoid Trees", rmClassID("classTrees"), 8.0);
	int avoidVeryCloseTrees=rmCreateClassDistanceConstraint("very close avoid Trees", rmClassID("classTrees"), 3.0);
	int avoidMediumTrees=rmCreateClassDistanceConstraint("medium avoid Trees", rmClassID("classTrees"), 25.0);
	int avoidFarTrees=rmCreateClassDistanceConstraint("far avoid Trees", rmClassID("classTrees"), 50.0);
	int avoidVeryFarTrees=rmCreateClassDistanceConstraint("very far avoid Trees", rmClassID("classTrees"), 75.0);
	
	// FRUITS AVOIDANCE:
	int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoids fruits", "berrybush", 15.0);  
    int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids fruits", "berrybush", 10.0);  
    int avoidVeryCloseFruits=rmCreateTypeDistanceConstraint("very close avoids fruits", "berrybush", 5.0); 
    int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium avoids fruits", "berrybush", 40.0); 	
    int avoidFarFruits=rmCreateTypeDistanceConstraint("far avoids fruits", "berrybush", 60.0); 
    int avoidVeryFarFruits=rmCreateTypeDistanceConstraint("very far avoids fruits", "berrybush", 75.0);  
    int avoidSuperFarElk=rmCreateTypeDistanceConstraint("super far avoids fruits", "berrybush", 60.0);  	
    
	
	int	avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", 15.0);
    int	avoidCloseFastCoin=rmCreateTypeDistanceConstraint("close avoids coin", "gold", 10.0);
    int	avoidVeryCloseFastCoin=rmCreateTypeDistanceConstraint("Very close avoids coin", "gold", 5.0);
    int	avoidFarFastCoin=rmCreateTypeDistanceConstraint("far avoids coin", "gold", 50.0);	
    
	// NUGGETS AVOIDANCE:
	int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 15.0);
    int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 10.0);
    int avoidVeryCloseNugget=rmCreateTypeDistanceConstraint("very close avoid nugget", "AbstractNugget", 5.0);
    int avoidFarNugget=rmCreateTypeDistanceConstraint("far avoid nugget", "AbstractNugget", 60.0);
  
	// ELK AVOIDANCE:
	int avoidElk=rmCreateTypeDistanceConstraint("elk avoids food", "elk", 15.0);  
    int avoidCloseElk=rmCreateTypeDistanceConstraint("close avoids food", "elk", 10.0);  
    int avoidVeryCloseElk=rmCreateTypeDistanceConstraint("very close avoids food", "elk", 5.0); 
    int avoidMediumElk=rmCreateTypeDistanceConstraint("medium avoids food", "elk", 40.0); 	
    int avoidFarElk=rmCreateTypeDistanceConstraint("far avoids food", "elk", 60.0);  
    	
	// MOOSE AVOIDANCE:
	int avoidMoose=rmCreateTypeDistanceConstraint("stuff avoids moose", "moose", 15.0);
    int avoidCloseMoose=rmCreateTypeDistanceConstraint("close avoids moose", "moose", 10.0);
    int avoidVeryCloseMoose=rmCreateTypeDistanceConstraint("very close avoids moose", "moose", 5.0);
	int avoidMediumMoose=rmCreateTypeDistanceConstraint("medium avoids moose", "moose", 40.0);
    int avoidFarMoose=rmCreateTypeDistanceConstraint("far avoids moose", "moose", 60.0);
	
	// SHEEP AVOIDANCE:
	int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoids sheep", "sheep", 15.0);  
    int avoidCloseSheep=rmCreateTypeDistanceConstraint("close avoids sheep", "sheep", 10.0);  
    int avoidVeryCloseSheep=rmCreateTypeDistanceConstraint("very close avoids sheep", "sheep", 5.0); 
    int avoidMediumSheep=rmCreateTypeDistanceConstraint("medium avoids sheep", "sheep", 40.0); 	
    int avoidFarSheep=rmCreateTypeDistanceConstraint("far avoids sheep", "sheep", 60.0);  

   // NATIVES AVOIDANCE:
	int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 15.0);
	int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 10.0);
	int avoidVeryCloseNatives=rmCreateClassDistanceConstraint("very close avoids natives", rmClassID("natives"), 5.0);
	int avoidNativesFar=rmCreateClassDistanceConstraint("stuff avoids natives far", rmClassID("natives"), 55.0);
	
   
    // Avoid impassable land
    int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 4.0);
    int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
    int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 10.0);

    // CONSTRAINT TO AVOID WATER:
    int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 4.0);
    int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water medium 8", "Land", false, 8.0);
    int avoidWater12 = rmCreateTerrainDistanceConstraint("avoid water medium 12", "Land", false, 12.0);
	int avoidWater15 = rmCreateTerrainDistanceConstraint("avoid water medium 15", "Land", false, 15.0);
    int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 20.0);
    int ferryOnShore=rmCreateTerrainMaxDistanceConstraint("ferry v. water", "water", true, 12.0);
    int flagConstraint=rmCreateHCGPConstraint("flags avoid same", 20.0);
    int nearWater10 = rmCreateTerrainDistanceConstraint("near water", "Water", true, 10.0);

    // NEW EXTRA STUFF FOR WATER SPAWN POINT AVOIDANCE:
	int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 15.0);
	int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 10);
	
	// Unit avoidance
   //int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
   //int avoidSocket = rmCreateClassDistanceConstraint("avoid socket", rmClassID("classSocket"), 10.0);
   int avoidImportantItem = rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 50.0);
   int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
   //int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route far", 20.0);

   int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 15.0);
   int avoidCloseStartingUnits=rmCreateClassDistanceConstraint("close avoid starting units", rmClassID("startingUnit"), 8.0);
   int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);

   int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));

   // ships vs. ships
   int shipVsShip=rmCreateTypeDistanceConstraint("ships avoid ship", "ship", 5.0);
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/

// DEFINE OBJECTS:
// THESE OBJECTS ARE ALL DEFINED SO THEY CAN BE PLACED LATER:

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE RIVER: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ******************* MAKE AREAS FOR THE MAIN ISLANDS... KINDA HACKY I GUESS, BUT IT WORKS: ******************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*
	    // BUILD AN INVISIBLE NORTH ISLAND AREA:
	    int northIslandID = rmCreateArea("north island");
	    rmSetAreaLocation(northIslandID, 0.75, 0.5); 
	    rmSetAreaWarnFailure(northIslandID, false);
	    rmSetAreaSize(northIslandID, 0.5, 0.5);
	    rmSetAreaCoherence(northIslandID, 1.0);
	    rmAddAreaConstraint(northIslandID, avoidWater4);
	    rmBuildArea(northIslandID);

        // BUILD AN INVISIBLE SOUTH ISLAND AREA:
        int southIslandID = rmCreateArea("south island");
        rmSetAreaLocation(southIslandID, 0.5, 0.25); 
        rmSetAreaWarnFailure(southIslandID, false);
        rmSetAreaSize(southIslandID, 0.5, 0.5);
        rmSetAreaCoherence(southIslandID, 1.0);
        rmAddAreaConstraint(southIslandID, avoidWater4);
        rmBuildArea(southIslandID);

        // ADD ISLAND CONSTRAINTS:
        int northIslandConstraint=rmCreateAreaConstraint("north Island", northIslandID);
		int avoidNorthIsland=rmCreateAreaDistanceConstraint("avoid north Island", northIslandID, 15);
        int southIslandConstraint=rmCreateAreaConstraint("south Island", southIslandID);
		int avoidSouthIsland=rmCreateAreaDistanceConstraint("avoid south Island", southIslandID, 15);
*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// *************************************** SET UP THE PLAYER LOCATIONS: ***************************************** //   
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if ( cNumberTeams == 2 )
   {
		rmSetPlacementSection(0.01, 0.99);
		rmPlacePlayersCircular(0.36, 0.36, 0.0);
   }
        else
   {
		rmSetPlacementSection(0.01, 0.99);
		rmPlacePlayersCircular(0.36, 0.36, 0.0);
   }	
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        //float playerFraction=rmAreaTilesToFraction(100);
		float playerFraction=rmAreaTilesToFraction(2250);
        
		for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
        
		// SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
		
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);

		// SET AREA MIX:
		//rmSetAreaMix(id, "texas_dirt");
		//rmSetAreaMix(id, "sonora_dirt");
		//rmSetAreaMix(id, "rockies_snow");
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "texas\ground2");
		//rmSetAreaTerrainType(id, "sonora\ground7_son");
		
		// SET AREA BASE HEIGHT:
		//rmSetAreaBaseHeight(id, 18.0);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
        // BUILD THE AREAS:
        rmBuildAllAreas();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE TRADE ROUTE: ************************************** //		
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		// CLEAR OUT CONSTRAINTS FOR GOOD MEASURE:
        rmClearClosestPointConstraints();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ***************************************** PLACE THE NATIVES TRIBES: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv0 == rmGetCivID("Nootka"))
	{  
		int nootkaVillageAID = -1;
		nootkaVillageAID = rmCreateGrouping("back nootka village", "native nootka village "+1);
		rmSetGroupingMinDistance(nootkaVillageAID, 0.0);
		rmSetGroupingMaxDistance(nootkaVillageAID, 0.0);
		rmAddGroupingToClass(nootkaVillageAID, rmClassID("natives"));
		rmAddGroupingConstraint(nootkaVillageAID, avoidNatives);
		rmPlaceGroupingAtLoc(nootkaVillageAID, 0, 0.15, 0.35);
	}
	
/*----------------------------------------------------------------------------------------------------------------*/	

	    if (subCiv1 == rmGetCivID("Klamath"))
	{  
		int klamathvillageBID = -1;
		klamathvillageBID = rmCreateGrouping("left city", "native klamath village "+2);
		rmSetGroupingMinDistance(klamathvillageBID, 0.0);
		rmSetGroupingMaxDistance(klamathvillageBID, 0.0);
		rmAddGroupingToClass(klamathvillageBID, rmClassID("natives"));
		rmAddGroupingConstraint(klamathvillageBID, avoidNatives);
		rmPlaceGroupingAtLoc(klamathvillageBID, 0, 0.35, 0.15);
	}
	
/*----------------------------------------------------------------------------------------------------------------*/
	    
		if (subCiv2 == rmGetCivID("Nootka"))
	{  
		int nootkavillageCID = -1;
		nootkavillageCID = rmCreateGrouping("right city", "native nootka village "+3);
		rmSetGroupingMinDistance(nootkavillageCID, 0.0);
		rmSetGroupingMaxDistance(nootkavillageCID, 20.0);
		rmAddGroupingToClass(nootkavillageCID, rmClassID("natives"));
		rmAddGroupingConstraint(nootkavillageCID, avoidNatives);
		rmPlaceGroupingAtLoc(nootkavillageCID, 0, 0.65, 0.85);
	}
	
/*----------------------------------------------------------------------------------------------------------------*/	

	    if (subCiv3 == rmGetCivID("Klamath"))
	{  
		int klamathvillageDID = -1;
		klamathvillageDID = rmCreateGrouping("front city", "native klamath village "+4);
		rmSetGroupingMinDistance(klamathvillageDID, 0.0);
		rmSetGroupingMaxDistance(klamathvillageDID, 20.0);
		rmAddGroupingToClass(klamathvillageDID, rmClassID("natives"));
		rmAddGroupingConstraint(klamathvillageDID, avoidNatives);
		rmPlaceGroupingAtLoc(klamathvillageDID, 0, 0.85, 0.65);
	}
	
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichMap == 1 )
		
{        
		if (subCiv4 == rmGetCivID("Nootka"))
	{  
		int nootkavillageEID = -1;
		nootkavillageEID = rmCreateGrouping("city1", "native nootka village "+3);
		rmSetGroupingMinDistance(nootkavillageEID, 0.0);
		rmSetGroupingMaxDistance(nootkavillageEID, 20.0);
		rmAddGroupingToClass(nootkavillageEID, rmClassID("natives"));
		rmAddGroupingConstraint(nootkavillageEID, avoidNatives);
		rmPlaceGroupingAtLoc(nootkavillageEID, 0, 0.15, 0.65);
	}
	
        if (subCiv5 == rmGetCivID("Nootka"))
	{  
		int nootkavillageFID = -1;
		nootkavillageFID = rmCreateGrouping("city2", "native nootka village "+4);
		rmSetGroupingMinDistance(nootkavillageFID, 0.0);
		rmSetGroupingMaxDistance(nootkavillageFID, 20.0);
		rmAddGroupingToClass(nootkavillageFID, rmClassID("natives"));
		rmAddGroupingConstraint(nootkavillageFID, avoidNatives);
		rmPlaceGroupingAtLoc(nootkavillageFID, 0, 0.85, 0.35);
	}
}

        else

{        
		if (subCiv4 == rmGetCivID("Klamath"))
	{  
		int klamathvillageEID = -1;
		klamathvillageEID = rmCreateGrouping("city3", "native klamath village "+3);
		rmSetGroupingMinDistance(klamathvillageEID, 0.0);
		rmSetGroupingMaxDistance(klamathvillageEID, 20.0);
		rmAddGroupingToClass(klamathvillageEID, rmClassID("natives"));
		rmAddGroupingConstraint(klamathvillageEID, avoidNatives);
		rmPlaceGroupingAtLoc(klamathvillageEID, 0, 0.35, 0.85);
	}
	
        if (subCiv5 == rmGetCivID("Klamath"))
	{  
		int klamathvillageFID = -1;
		klamathvillageFID = rmCreateGrouping("city4", "native klamath village "+4);
		rmSetGroupingMinDistance(klamathvillageFID, 0.0);
		rmSetGroupingMaxDistance(klamathvillageFID, 20.0);
		rmAddGroupingToClass(klamathvillageFID, rmClassID("natives"));
		rmAddGroupingConstraint(klamathvillageFID, avoidNatives);
		rmPlaceGroupingAtLoc(klamathvillageFID, 0, 0.65, 0.15);
	}
}	
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/

// ************************************ DEFINE AND PLACE THE CENTRAL POND: ************************************** //
/*================================================================================================================*/	
      
	    int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("things avoid the pond", rmClassID("pond"), 20.0);
        int pondCloseConstraint=rmCreateClassDistanceConstraint("close avoid the pond", rmClassID("pond"), 10.0);
        int pondVeryCloseConstraint=rmCreateClassDistanceConstraint("very close avoid the pond", rmClassID("pond"), 5.0);
       
	   
	    int smallPondID=rmCreateArea("small pond");
		rmSetAreaSize(smallPondID, 0.065, 0.065);
		rmSetAreaWaterType(smallPondID, "Northwest Territory Water");
		rmSetAreaBaseHeight(smallPondID, 4);
		rmSetAreaMinBlobs(smallPondID, 1);
		rmSetAreaMaxBlobs(smallPondID, 4);
		rmSetAreaMinBlobDistance(smallPondID, 5.0);
		rmSetAreaMaxBlobDistance(smallPondID, 30.0);
		rmAddAreaToClass(smallPondID, pondClass);
		rmSetAreaCoherence(smallPondID, 0.5);
		rmSetAreaSmoothDistance(smallPondID, 5);
		
		rmAddAreaConstraint(smallPondID, playerConstraint);
		
		rmSetAreaWarnFailure(smallPondID, false);
		rmSetAreaLocation(smallPondID, 0.5, 0.5); 
		rmBuildArea(smallPondID);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ************************* DEFINE THE STARTING TCID AND STARTING UNITS AND RESOURCES: ************************* //
/*================================================================================================================*/

   	    // DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 6.0);
	    rmSetObjectDefMaxDistance(startingUnits, 10.0);
		rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startingUnits, avoidAll);
	    rmAddObjectDefConstraint(startingUnits, avoidWater8);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE THE STARTING TCID:
		int startingTCID= rmCreateObjectDef("startingTC");
	    
		if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    
		rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
		rmSetObjectDefMinDistance(startingTCID, 0.0);
		rmSetObjectDefMaxDistance(startingTCID, 0.0);
	
/*----------------------------------------------------------------------------------------------------------------*/

	    // DEFINE THE START AREA TREE:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeNorthwestTerritory", rmRandInt(3,7), 8.0);
		rmAddObjectDefToClass(StartAreaTreeID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(StartAreaTreeID, 23.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 25.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidCloseStartingUnits);

	    // DEFINE THE START DEER:
		int StartDeerID=rmCreateObjectDef("starting deer");
	    rmAddObjectDefItem(StartDeerID, "deer", 1, 0.0);
		rmAddObjectDefToClass(StartDeerID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(StartDeerID, 14.0);
	    rmSetObjectDefMaxDistance(StartDeerID, 16.0);
	    rmAddObjectDefConstraint(StartDeerID, avoidCloseStartingUnits);
		
		// DEFINE THE START BERRIES:
		int StartBerriesID=rmCreateObjectDef("starting berries");
	    rmAddObjectDefItem(StartBerriesID, "berrybush", rmRandInt(3,7), 5.0);
		rmAddObjectDefToClass(StartBerriesID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(StartBerriesID, 18.0);
	    rmSetObjectDefMaxDistance(StartBerriesID, 21.0);
	    rmAddObjectDefConstraint(StartBerriesID, avoidCloseStartingUnits);

        // DEFINE THE VARIABLES FOR THE PLAYER GOLD:
		int silverID = -1;
	    int silverType = rmRandInt(1,10);
	    int playerGoldID = -1;

	    // DEFINE THE VARIABLE FOR THE WATER FLAG:
		int waterFlagID = -1;
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// *************************** PLACE THE STARTING TCID AND STARTING UNITS AND RESOURCES: ************************ //
/*================================================================================================================*/

	    for(i=1; <cNumberPlayers)
	{
		// PLACE THE STARTING UNITS AND STARTING TCID:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// DEFINE THE PLAYER GOLD:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		rmAddObjectDefToClass(playerGoldID, rmClassID("startingUnit"));
		rmAddObjectDefConstraint(playerGoldID, avoidCloseStartingUnits);
		rmAddObjectDefConstraint(playerGoldID, avoidWater8);
		rmSetObjectDefMinDistance(playerGoldID, 27.0);
		rmSetObjectDefMaxDistance(playerGoldID, 29.0);
		
		// PLACE THE PLAYER GOLD:
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING DEERS:
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING BERRIES:
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE START AREA TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// DEFINE THE WATER FLAG:
		waterFlagID=rmCreateObjectDef("HC water flag "+i);
		rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
        vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

		// PLACE THE WATER FLAG:
		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		rmClearClosestPointConstraints();
	}

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE CLIFFS: ***************************************** //
/*================================================================================================================*/
		
	int cliffClass=rmDefineClass("classCliff");
    int cliffConstraint=rmCreateClassDistanceConstraint("things avoid the cliff", rmClassID("classCliff"), 20.0);
    int cliffCloseConstraint=rmCreateClassDistanceConstraint("close avoid the cliff", rmClassID("classCliff"), 10.0);
    int cliffVeryCloseConstraint=rmCreateClassDistanceConstraint("very close avoid the cliff", rmClassID("classCliff"), 5.0);
	
/*----------------------------------------------------------------------------------------------------------------*/
		
		// THE EASTERN CLIFFS:
		int cliffEastID=rmCreateArea("cliff east");
	    rmSetAreaSize(cliffEastID, 0.015, 0.015);  
		rmSetAreaWarnFailure(cliffEastID, false);
		rmSetAreaCliffType(cliffEastID, "Patagonia");
		rmAddAreaToClass(cliffEastID, rmClassID("classCliff"));	
		rmSetAreaCliffEdge(cliffEastID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliffEastID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliffEastID, 7, 1.0, 1.0);
		rmSetAreaHeightBlend(cliffEastID, 1);
		rmSetAreaObeyWorldCircleConstraint(cliffEastID, false);
		
		rmAddAreaConstraint(cliffEastID, cliffConstraint);				
		
		rmSetAreaMinBlobs(cliffEastID, 1);
		rmSetAreaMaxBlobs(cliffEastID, 1);
		rmSetAreaMinBlobDistance(cliffEastID, 1.0);
		rmSetAreaMaxBlobDistance(cliffEastID, 1.0);
		
		rmSetAreaSmoothDistance(cliffEastID, 5);						
		rmSetAreaCoherence(cliffEastID, 0.65);
		rmSetAreaLocation(cliffEastID, 0.75, 0.25); 

		rmBuildArea(cliffEastID);
	
/*----------------------------------------------------------------------------------------------------------------*/
		   
		// THE WESTERN CLIFFS:
		int cliffWestID=rmCreateArea("cliff west");
		rmSetAreaSize(cliffWestID, 0.015, 0.015);  
	    rmSetAreaWarnFailure(cliffWestID, false);
		rmSetAreaCliffType(cliffWestID, "Patagonia");
		rmAddAreaToClass(cliffWestID, rmClassID("classCliff"));	
		rmSetAreaCliffEdge(cliffWestID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliffWestID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliffWestID, 7, 1.0, 1.0);
		rmSetAreaHeightBlend(cliffWestID, 1);
		rmSetAreaObeyWorldCircleConstraint(cliffWestID, false);
		
		rmAddAreaConstraint(cliffWestID, cliffConstraint);			
				
		rmSetAreaMinBlobs(cliffWestID, 1);
		rmSetAreaMaxBlobs(cliffWestID, 1);
		rmSetAreaMinBlobDistance(cliffWestID, 1.0);
		rmSetAreaMaxBlobDistance(cliffWestID, 1.0);
		
		rmSetAreaSmoothDistance(cliffWestID, 5);	
		rmSetAreaCoherence(cliffWestID, 0.65);
		rmSetAreaLocation(cliffWestID, 0.25, 0.75); 

		rmBuildArea(cliffWestID);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NORTHERN CLIFFS:
		int cliffNorthID=rmCreateArea("cliff North");
		rmSetAreaSize(cliffNorthID, 0.015, 0.015);  
	    rmSetAreaWarnFailure(cliffNorthID, false);
		rmSetAreaCliffType(cliffNorthID, "Patagonia");
		rmAddAreaToClass(cliffNorthID, rmClassID("classCliff"));	
		rmSetAreaCliffEdge(cliffNorthID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliffNorthID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliffNorthID, 7, 1.0, 1.0);
		rmSetAreaHeightBlend(cliffNorthID, 1);
		rmSetAreaObeyWorldCircleConstraint(cliffNorthID, false);
		
		rmAddAreaConstraint(cliffNorthID, cliffConstraint);			
				
		rmSetAreaMinBlobs(cliffNorthID, 1);
		rmSetAreaMaxBlobs(cliffNorthID, 1);
		rmSetAreaMinBlobDistance(cliffNorthID, 1.0);
		rmSetAreaMaxBlobDistance(cliffNorthID, 1.0);
		
		rmSetAreaSmoothDistance(cliffNorthID, 5);	
		rmSetAreaCoherence(cliffNorthID, 0.65);
		rmSetAreaLocation(cliffNorthID, 0.75, 0.75); 

		rmBuildArea(cliffNorthID);	

/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN CLIFFS:
		int cliffSouthID=rmCreateArea("cliff South");
		rmSetAreaSize(cliffSouthID, 0.015, 0.015);  
	    rmSetAreaWarnFailure(cliffSouthID, false);
		rmSetAreaCliffType(cliffSouthID, "Patagonia");
		rmAddAreaToClass(cliffSouthID, rmClassID("classCliff"));	
		rmSetAreaCliffEdge(cliffSouthID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliffSouthID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliffSouthID, 7, 1.0, 1.0);
		rmSetAreaHeightBlend(cliffSouthID, 1);
		rmSetAreaObeyWorldCircleConstraint(cliffSouthID, false);
		
		rmAddAreaConstraint(cliffSouthID, cliffConstraint);			
				
		rmSetAreaMinBlobs(cliffSouthID, 1);
		rmSetAreaMaxBlobs(cliffSouthID, 1);
		rmSetAreaMinBlobDistance(cliffSouthID, 1.0);
		rmSetAreaMaxBlobDistance(cliffSouthID, 1.0);
		
		rmSetAreaSmoothDistance(cliffSouthID, 5);	
		rmSetAreaCoherence(cliffSouthID, 0.65);
		rmSetAreaLocation(cliffSouthID, 0.25, 0.25); 

		rmBuildArea(cliffSouthID);	
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE FORESTS: ***************************************** //
/*================================================================================================================*/

        int forestTreeID = 0;
		
		if (cNumberNonGaiaPlayers<=2)
		int numTries=8*cNumberNonGaiaPlayers;
		else
		numTries=4*cNumberNonGaiaPlayers;
        
		int failCount=0;
        int whichForest=-1;
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
        // THE NORTHERN FORESTS:
		for (i=0; <numTries)
{   
        int forest=rmCreateArea("forest "+i);
		whichForest=rmRandInt(1, 2);
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(175), rmAreaTilesToFraction(350));
        
		if ( whichForest == 1 )
	{
		rmSetAreaForestType(forest, "NW Territory Birch Forest");
	}
		else
	{
		rmSetAreaForestType(forest, "NW Territory Forest");
	}
        
		rmSetAreaForestDensity(forest, 1.0);
        rmSetAreaForestClumpiness(forest, 0.25);
        rmSetAreaForestUnderbrush(forest, 0.50);
        rmSetAreaCoherence(forest, 0.65);
        rmSetAreaSmoothDistance(forest, 5);
        rmAddAreaToClass(forest, rmClassID("classForest")); 
        
		rmAddAreaConstraint(forest, forestFarConstraint);
		rmAddAreaConstraint(forest, playerEdgeConstraint);
		rmAddAreaConstraint(forest, playerCloseConstraint);
		rmAddAreaConstraint(forest, pondCloseConstraint);
		rmAddAreaConstraint(forest, cliffCloseConstraint);
		rmAddAreaConstraint(forest, Northward);
		rmAddAreaConstraint(forest, avoidCloseNatives);
        rmAddAreaConstraint(forest, avoidAll);
    
		if(rmBuildArea(forest)==false)
    {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==5)
        break;
    }
        else
        failCount=0; 
} 

/*----------------------------------------------------------------------------------------------------------------*/
        
		// THE SOUTHERN FORESTS:
		for (i=0; <numTries)
{   
        int forest2=rmCreateArea("forest2 "+i);
		whichForest=rmRandInt(1, 2);
        rmSetAreaWarnFailure(forest2, false);
        rmSetAreaSize(forest2, rmAreaTilesToFraction(175), rmAreaTilesToFraction(350));
        
		if ( whichForest == 1 )
	{
		rmSetAreaForestType(forest2, "NW Territory Birch Forest");
	}
		else
	{
		rmSetAreaForestType(forest2, "NW Territory Forest");
	}
        
		rmSetAreaForestDensity(forest2, 1.0);
        rmSetAreaForestClumpiness(forest2, 0.25);
        rmSetAreaForestUnderbrush(forest2, 0.50);
        rmSetAreaCoherence(forest2, 0.65);
        rmSetAreaSmoothDistance(forest2, 5);
        rmAddAreaToClass(forest2, rmClassID("classForest")); 
        
		rmAddAreaConstraint(forest2, forestFarConstraint);
		rmAddAreaConstraint(forest2, playerEdgeConstraint);
		rmAddAreaConstraint(forest2, playerCloseConstraint);
		rmAddAreaConstraint(forest2, pondCloseConstraint);
		rmAddAreaConstraint(forest2, cliffCloseConstraint);
		rmAddAreaConstraint(forest2, Southward);
		rmAddAreaConstraint(forest2, avoidCloseNatives);
        rmAddAreaConstraint(forest2, avoidAll);
		        
		if(rmBuildArea(forest2)==false)
    {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==5)
        break;
    }
        else
        failCount=0; 
} 

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE FAST COIN: **************************************** //
/*================================================================================================================*/
        
		silverID = -1;
		int silver2ID = -1;
	    silverType = rmRandInt(1,10);
		
		if (cNumberNonGaiaPlayers<=2)
		int silverCount = (cNumberNonGaiaPlayers*4);
		else
		silverCount = (cNumberNonGaiaPlayers*2);
	    
		rmEchoInfo("silver count = "+silverCount);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // THE NORTHERN SILVER:
		for(i=0; < silverCount)
	{
		silverType = rmRandInt(1,1);
		silverID = rmCreateObjectDef("silver "+i);
		rmAddObjectDefItem(silverID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silverID, 0.0);
		rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(silverID, avoidFarFastCoin);
		rmAddObjectDefConstraint(silverID, avoidAll);
		rmAddObjectDefConstraint(silverID, forestCloseConstraint);
		rmAddObjectDefConstraint(silverID, Northward);
		rmAddObjectDefConstraint(silverID, avoidCloseNatives);
		rmAddObjectDefConstraint(silverID, cliffCloseConstraint);
		rmAddObjectDefConstraint(silverID, playerCloseConstraint);
		rmAddObjectDefConstraint(silverID, playerCloseEdgeConstraint);
		rmAddObjectDefConstraint(silverID, pondCloseConstraint);
				
		rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
   }
   
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN SILVER:
		for(i=0; < silverCount)
	{
		silverType = rmRandInt(1,1);
		silver2ID = rmCreateObjectDef("silver 2 "+i);
		rmAddObjectDefItem(silver2ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silver2ID, 0.0);
		rmSetObjectDefMaxDistance(silver2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(silver2ID, avoidFarFastCoin);
		rmAddObjectDefConstraint(silver2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(silver2ID, avoidAll);
		rmAddObjectDefConstraint(silver2ID, Southward);
		rmAddObjectDefConstraint(silver2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(silver2ID, cliffCloseConstraint);
		rmAddObjectDefConstraint(silver2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(silver2ID, playerCloseEdgeConstraint);
		rmAddObjectDefConstraint(silver2ID, pondCloseConstraint);
				
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.5, 0.5);
   }  

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.86);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE NUGGETS: ***************************************** //
/*================================================================================================================*/

	    // THE NORTHERN NUGGETS:
		int nuggetID= rmCreateObjectDef("The Northern Nuggets"); 
	    rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nuggetID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(nuggetID, avoidFarNugget);
		rmAddObjectDefConstraint(nuggetID, avoidFastCoin);
  	    rmAddObjectDefConstraint(nuggetID, forestCloseConstraint);
  	    rmAddObjectDefConstraint(nuggetID, avoidAll);
		rmAddObjectDefConstraint(nuggetID, Northward);
		rmAddObjectDefConstraint(nuggetID, playerCloseConstraint);
		rmAddObjectDefConstraint(nuggetID, playerEdgeConstraint);
		rmAddObjectDefConstraint(nuggetID, avoidCloseNatives);
		rmAddObjectDefConstraint(nuggetID, cliffCloseConstraint);
  	    rmAddObjectDefConstraint(nuggetID, pondCloseConstraint);
	    	    
		rmSetNuggetDifficulty(1, 2);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4.0);		
		else
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN NUGGETS:
		int nugget2ID= rmCreateObjectDef("The Southern Nuggets"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(nugget2ID, avoidFarNugget);
		rmAddObjectDefConstraint(nugget2ID, avoidFastCoin);
  	    rmAddObjectDefConstraint(nugget2ID, forestCloseConstraint);
  	    rmAddObjectDefConstraint(nugget2ID, avoidAll);
		rmAddObjectDefConstraint(nugget2ID, Southward);
		rmAddObjectDefConstraint(nugget2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(nugget2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(nugget2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(nugget2ID, cliffCloseConstraint);
  	    rmAddObjectDefConstraint(nugget2ID, pondCloseConstraint);
	    	    
		rmSetNuggetDifficulty(1, 2);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4.0);		
		else
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.87);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE ELK HERDS: *************************************** //
/*================================================================================================================*/

        // THE NORTHERN ELK HERDS:
		int elkID=rmCreateObjectDef("The Northern Elk Herds");
	    
		int bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(elkID, "elk", rmRandInt(4,6), 5.0);
	    else
		rmAddObjectDefItem(elkID, "elk", rmRandInt(8,10), 7.0);
	    
		rmSetObjectDefMinDistance(elkID, 0.0);
	    rmSetObjectDefMaxDistance(elkID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(elkID, avoidFarElk);
	    rmAddObjectDefConstraint(elkID, avoidNugget);
		rmAddObjectDefConstraint(elkID, avoidFastCoin);
  	    rmAddObjectDefConstraint(elkID, forestCloseConstraint);
  	    rmAddObjectDefConstraint(elkID, avoidAll);
		rmAddObjectDefConstraint(elkID, Northward);
		rmAddObjectDefConstraint(elkID, playerCloseConstraint);
		rmAddObjectDefConstraint(elkID, playerEdgeConstraint);
		rmAddObjectDefConstraint(elkID, avoidCloseNatives);
		rmAddObjectDefConstraint(elkID, cliffCloseConstraint);
  	    rmAddObjectDefConstraint(elkID, pondCloseConstraint);
		
	    rmSetObjectDefCreateHerd(elkID, true);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(elkID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);				
		else
		rmPlaceObjectDefAtLoc(elkID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);	

/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN ELK HERDS:
		int elk2ID=rmCreateObjectDef("The Southern Elk Herds");
	    
		bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(elk2ID, "elk", rmRandInt(4,6), 5.0);
	    else
		rmAddObjectDefItem(elk2ID, "elk", rmRandInt(8,10), 7.0);
	    
		rmSetObjectDefMinDistance(elk2ID, 0.0);
	    rmSetObjectDefMaxDistance(elk2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(elk2ID, avoidFarElk);
	    rmAddObjectDefConstraint(elk2ID, avoidNugget);
		rmAddObjectDefConstraint(elk2ID, avoidFastCoin);
  	    rmAddObjectDefConstraint(elk2ID, forestCloseConstraint);
  	    rmAddObjectDefConstraint(elk2ID, avoidAll);
		rmAddObjectDefConstraint(elk2ID, Southward);
		rmAddObjectDefConstraint(elk2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(elk2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(elk2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(elk2ID, cliffCloseConstraint);
  	    rmAddObjectDefConstraint(elk2ID, pondCloseConstraint);
		
	    rmSetObjectDefCreateHerd(elk2ID, true);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(elk2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);				
		else
		rmPlaceObjectDefAtLoc(elk2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.88);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE MOOSE HERDS: ************************************* //
/*================================================================================================================*/

        // THE NORTHERN MOOSE HERDS:
		int mooseID=rmCreateObjectDef("The Northern Moose Herds");
	    
		bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(mooseID, "moose", rmRandInt(3,5), 5.0);
	    else
		rmAddObjectDefItem(mooseID, "moose", rmRandInt(5,7), 7.0);
	    
		rmSetObjectDefMinDistance(mooseID, 0.0);
	    rmSetObjectDefMaxDistance(mooseID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(mooseID, avoidAll);
	    rmAddObjectDefConstraint(mooseID, avoidFarMoose);
		rmAddObjectDefConstraint(mooseID, avoidMediumElk);
	    rmAddObjectDefConstraint(mooseID, avoidNugget);
		rmAddObjectDefConstraint(mooseID, avoidFastCoin);
  	    rmAddObjectDefConstraint(mooseID, forestCloseConstraint);
  	    rmAddObjectDefConstraint(mooseID, Northward);
		rmAddObjectDefConstraint(mooseID, playerCloseConstraint);
		rmAddObjectDefConstraint(mooseID, playerEdgeConstraint);
		rmAddObjectDefConstraint(mooseID, avoidCloseNatives);
		rmAddObjectDefConstraint(mooseID, cliffCloseConstraint);
  	    rmAddObjectDefConstraint(mooseID, pondCloseConstraint);
	    	    
		rmSetObjectDefCreateHerd(mooseID, true);
	    
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(mooseID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
		else
		rmPlaceObjectDefAtLoc(mooseID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN MOOSE HERDS:
		int moose2ID=rmCreateObjectDef("The Southern Moose Herds");
	    
		bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(moose2ID, "moose", rmRandInt(3,5), 5.0);
	    else
		rmAddObjectDefItem(moose2ID, "moose", rmRandInt(5,7), 7.0);
	    
		rmSetObjectDefMinDistance(moose2ID, 0.0);
	    rmSetObjectDefMaxDistance(moose2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(moose2ID, avoidAll);
	    rmAddObjectDefConstraint(moose2ID, avoidFarMoose);
		rmAddObjectDefConstraint(moose2ID, avoidMediumElk);
	    rmAddObjectDefConstraint(moose2ID, avoidNugget);
		rmAddObjectDefConstraint(moose2ID, avoidFastCoin);
  	    rmAddObjectDefConstraint(moose2ID, forestCloseConstraint);
  	    rmAddObjectDefConstraint(moose2ID, Southward);
		rmAddObjectDefConstraint(moose2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(moose2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(moose2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(moose2ID, cliffCloseConstraint);
  	    rmAddObjectDefConstraint(moose2ID, pondCloseConstraint);
	    	    
		rmSetObjectDefCreateHerd(moose2ID, true);
	    
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(moose2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
		else
		rmPlaceObjectDefAtLoc(moose2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.89);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE SHEEP HERDS: ************************************* //
/*================================================================================================================*/

        if (cNumberNonGaiaPlayers<=2)
		int sheepCount =3*cNumberNonGaiaPlayers;
		else
		sheepCount =1.5*cNumberNonGaiaPlayers;
		    
		rmEchoInfo("sheep count = "+sheepCount);
			
/*----------------------------------------------------------------------------------------------------------------*/			
		    
		// THE NORTHERN SHEEP HERDS:
		for (i=0; <sheepCount)
	{
		int sheepID = rmCreateObjectDef("The Northern Sheep Herds "+i);
		rmAddObjectDefItem(sheepID, "sheep", rmRandInt(3,5), 4);
		rmSetObjectDefMinDistance(sheepID, 0.0);
		rmSetObjectDefMaxDistance(sheepID, rmXFractionToMeters(0.5));
			
		rmAddObjectDefConstraint(sheepID, avoidAll);
		rmAddObjectDefConstraint(sheepID, avoidFarSheep);
	    rmAddObjectDefConstraint(sheepID, avoidMediumMoose);
		rmAddObjectDefConstraint(sheepID, avoidMediumElk);
	    rmAddObjectDefConstraint(sheepID, avoidNugget);
		rmAddObjectDefConstraint(sheepID, avoidFastCoin);
  	    rmAddObjectDefConstraint(sheepID, forestCloseConstraint);
  	    rmAddObjectDefConstraint(sheepID, Northward);
		rmAddObjectDefConstraint(sheepID, playerCloseConstraint);
		rmAddObjectDefConstraint(sheepID, playerEdgeConstraint);
		rmAddObjectDefConstraint(sheepID, avoidCloseNatives);
		rmAddObjectDefConstraint(sheepID, cliffCloseConstraint);
  	    rmAddObjectDefConstraint(sheepID, pondCloseConstraint);
			
		rmSetObjectDefCreateHerd(sheepID, false);

		rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5);		
	}
	
/*----------------------------------------------------------------------------------------------------------------*/

	    // THE SOUTHERN SHEEP HERDS:
		for (i=0; <sheepCount)
	{
		int sheep2ID = rmCreateObjectDef("The Southern Sheep Herds "+i);
		rmAddObjectDefItem(sheep2ID, "sheep", rmRandInt(3,5), 4);
		rmSetObjectDefMinDistance(sheep2ID, 0.0);
		rmSetObjectDefMaxDistance(sheep2ID, rmXFractionToMeters(0.5));
			
		rmAddObjectDefConstraint(sheep2ID, avoidAll);
		rmAddObjectDefConstraint(sheep2ID, avoidFarSheep);
	    rmAddObjectDefConstraint(sheep2ID, avoidMediumMoose);
		rmAddObjectDefConstraint(sheep2ID, avoidMediumElk);
	    rmAddObjectDefConstraint(sheep2ID, avoidNugget);
		rmAddObjectDefConstraint(sheep2ID, avoidFastCoin);
  	    rmAddObjectDefConstraint(sheep2ID, forestCloseConstraint);
  	    rmAddObjectDefConstraint(sheep2ID, Southward);
		rmAddObjectDefConstraint(sheep2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(sheep2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(sheep2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(sheep2ID, cliffCloseConstraint);
  	    rmAddObjectDefConstraint(sheep2ID, pondCloseConstraint);
			
		rmSetObjectDefCreateHerd(sheep2ID, false);

		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.5, 0.5);		
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE RANDOM TREES: ************************************** //
/*================================================================================================================*/
    
		// THE NORTHERN RANDOM TREES: 
		int randomTreeID=rmCreateObjectDef("The Northern Random Trees "+i);
		
		rmAddObjectDefItem(randomTreeID, "TreeNorthwestTerritory", rmRandInt(2,5), 3.0);
			
		rmAddObjectDefToClass(randomTreeID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
		rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseTrees);	
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseSheep);
	    rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseMoose);
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseElk);
	    rmAddObjectDefConstraint(randomTreeID, Northward);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTreeID, cliffCloseConstraint);
  	    rmAddObjectDefConstraint(randomTreeID, playerVeryCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidAll);
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseNugget);
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseFastCoin);
		rmAddObjectDefConstraint(randomTreeID, forestVeryCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, playerEdgeConstraint);
		rmAddObjectDefConstraint(randomTreeID, pondVeryCloseConstraint);
        		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*20);				
		else
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*10);
		
/*----------------------------------------------------------------------------------------------------------------*/	
		
        // THE SOUTHERN RANDOM TREES: 
		int randomTree2ID=rmCreateObjectDef("The Southern Random Trees "+i);
		
		rmAddObjectDefItem(randomTree2ID, "TreeNorthwestTerritory", rmRandInt(2,5), 3.0);
			
		rmAddObjectDefToClass(randomTree2ID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTree2ID, 0.0);
		rmSetObjectDefMaxDistance(randomTree2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseTrees);	
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseSheep);
	    rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseMoose);
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseElk);
	    rmAddObjectDefConstraint(randomTree2ID, Southward);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTree2ID, cliffCloseConstraint);
  	    rmAddObjectDefConstraint(randomTree2ID, playerVeryCloseConstraint);
		rmAddObjectDefConstraint(randomTree2ID, avoidAll);
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseNugget);
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseFastCoin);
		rmAddObjectDefConstraint(randomTree2ID, forestVeryCloseConstraint);
		rmAddObjectDefConstraint(randomTree2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(randomTree2ID, pondVeryCloseConstraint);
        		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*20);				
		else
		rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*10);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.91);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE RANDOM BERRIES: ************************************* //
/*================================================================================================================*/
    
		// THE NORTHERN RANDOM BERRIES: 
		int randomBerriesID=rmCreateObjectDef("The Northern Random Berries "+i);
		rmAddObjectDefItem(randomBerriesID, "berrybush", rmRandInt(2,5), 3.0);
		rmSetObjectDefMinDistance(randomBerriesID, 0.0);
		rmSetObjectDefMaxDistance(randomBerriesID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomBerriesID, avoidFarFruits);	
		rmAddObjectDefConstraint(randomBerriesID, avoidCloseTrees);	
		rmAddObjectDefConstraint(randomBerriesID, avoidVeryCloseSheep);
	    rmAddObjectDefConstraint(randomBerriesID, avoidVeryCloseMoose);
		rmAddObjectDefConstraint(randomBerriesID, avoidVeryCloseElk);
	    rmAddObjectDefConstraint(randomBerriesID, Northward);
		rmAddObjectDefConstraint(randomBerriesID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomBerriesID, cliffCloseConstraint);
  	    rmAddObjectDefConstraint(randomBerriesID, playerVeryCloseConstraint);
		rmAddObjectDefConstraint(randomBerriesID, avoidAll);
		rmAddObjectDefConstraint(randomBerriesID, avoidVeryCloseNugget);
		rmAddObjectDefConstraint(randomBerriesID, avoidVeryCloseFastCoin);
		rmAddObjectDefConstraint(randomBerriesID, forestVeryCloseConstraint);
		rmAddObjectDefConstraint(randomBerriesID, playerEdgeConstraint);
		rmAddObjectDefConstraint(randomBerriesID, pondVeryCloseConstraint);
        		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomBerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);				
		else
		rmPlaceObjectDefAtLoc(randomBerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN RANDOM BERRIES: 
		int randomBerries2ID=rmCreateObjectDef("The Southern Random Berries "+i);
		
		rmAddObjectDefItem(randomBerries2ID, "berrybush", rmRandInt(2,5), 3.0);
		rmSetObjectDefMinDistance(randomBerries2ID, 0.0);
		rmSetObjectDefMaxDistance(randomBerries2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomBerries2ID, avoidFarFruits);	
		rmAddObjectDefConstraint(randomBerries2ID, avoidCloseTrees);	
		rmAddObjectDefConstraint(randomBerries2ID, avoidVeryCloseSheep);
	    rmAddObjectDefConstraint(randomBerries2ID, avoidVeryCloseMoose);
		rmAddObjectDefConstraint(randomBerries2ID, avoidVeryCloseElk);
	    rmAddObjectDefConstraint(randomBerries2ID, Southward);
		rmAddObjectDefConstraint(randomBerries2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomBerries2ID, cliffCloseConstraint);
  	    rmAddObjectDefConstraint(randomBerries2ID, playerVeryCloseConstraint);
		rmAddObjectDefConstraint(randomBerries2ID, avoidAll);
		rmAddObjectDefConstraint(randomBerries2ID, avoidVeryCloseNugget);
		rmAddObjectDefConstraint(randomBerries2ID, avoidVeryCloseFastCoin);
		rmAddObjectDefConstraint(randomBerries2ID, forestVeryCloseConstraint);
		rmAddObjectDefConstraint(randomBerries2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(randomBerries2ID, pondVeryCloseConstraint);
        		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomBerries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);				
		else
		rmPlaceObjectDefAtLoc(randomBerries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
        
		int fishID=rmCreateObjectDef("fish");
	    rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
	    rmSetObjectDefMinDistance(fishID, 0.0);
	    rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(fishID, fishVsFishID);
	    rmAddObjectDefConstraint(fishID, fishLand);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 16*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 8*cNumberNonGaiaPlayers);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/










